package cn.com.ctop.job.kuaishou.handler;

import cn.com.ctop.common.module.entity.CtopOauthToken;
import cn.com.ctop.common.module.service.ICtopOauthTokenService;
import cn.com.ctop.kuaishou.modules.report.service.IKuaishouReportDailyImageService;
import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.annotation.XxlJob;
import org.jeecg.common.util.DateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

@Component
public class KuaiShouDailyImageReportLoadJob {
    @Autowired
    private ICtopOauthTokenService tokenService;
    @Autowired
    private IKuaishouReportDailyImageService kuaishouReportDailyImageService;
    static ExecutorService executorService = Executors.newFixedThreadPool(8);
    @XxlJob("kuaiShouDailyImageReportLoadJob")
    public void execute() throws Exception {
        //增加接口的开始和结束日期
        String nowDate = DateUtils.getNowDate("yyyy-MM-dd");
        String yesterdayDate = DateUtils.getAnotherDay("yyyy-MM-dd", nowDate, -1);
        //1:查询当日数据
        List<CtopOauthToken> tokens = tokenService.selectKuaiShouToken();
        tokens.forEach(token -> executorService.submit(() -> {
            kuaishouReportDailyImageService.getMaterialImageReport(token.getAccountId(),token.getAccessToken(),yesterdayDate,yesterdayDate,1);
        }));
        XxlJobHelper.log("快手图片消耗报表同步完成");
    }
}
